Relog = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0","AceDB-2.0","AceEvent-2.0","Parser-3.0")

local DefaultConfig={
	--Abbreviations reduce space stored for the log
	Abbrev={},	--Table converts from string to abbreviation (a number)
	RAbbrev={},	--Table converts from abbreviation to string

	--The parsed combat log
	StartLog=1,
	LastLog=0,
	NextLog=1,
	Log={
		Time={},
		Time2={},
		Source={},
		Victim={},
		Type={},	--What type of log message is this?
		Ability={},
		Result={},
		Amount={},

		--Special Data for Damage
		absorbAmount={},
		blockAmount={},
		resistAmount={},
		vulnerableAmount={},

		--Item Data
		itemLink={},
		itemName={},
		itemRarity={},
		itemString={},

		--Items just for Experience which requires several
		bonusAmount={},
		bonusType={},
		penaltyAmount={},
		penaltyType={},
		amountRaidPenalty={},
		amountGroupBonus={},
	},

	--Units and their time based data
	Units={
		UnitID={},
		
		--Attributes
		Friendly={},
		isPlayer={},
		Class={},
		Faction={},
		
		--Stats
		Health={},
		HealthMax={},
		Power={},
		PowerMax={},
		PowerType={},
		MinRange={},
		MaxRange={},

		--PvP (use with GetPVPRankInfo and UnitPVPRank)
		RankName={},
		RankNumber={},
	}
}

Relog:RegisterDB("RelogDB","RelogPerCharDB")
Relog:RegisterDefaults('char',DefaultConfig)	




--Subsecond determining by enclosing a range at second flips
Relog.SubLower=0
Relog.SubWidth=2

local AcceptedWidth=0.0025

function Relog:DetermineSubsecond()
	local UpperTime=GetTime()
	local CurTime=time()

	if (CurTime-Relog.SubLastTime2)==1 then
		--1 second difference
		local LowerTime=Relog.SubLastTime
		local Width=UpperTime-LowerTime
		LowerTime=LowerTime-math.floor(LowerTime)

		if Relog.SubLower<LowerTime then
			Relog.SubWidth=Relog.SubWidth-(LowerTime-Relog.SubLower)
			Relog.SubLower=LowerTime

			--Relog:Print("Raised Lower to "..LowerTime)
		end

		if (Relog.SubWidth+Relog.SubLower)>(Width+LowerTime) then
			Relog.SubWidth=Width+LowerTime-Relog.SubLower
			--Relog:Print("Reduced Width to "..Relog.SubWidth)
		end

		if Relog.SubWidth<AcceptedWidth then
			--Relog:Print("Finished with range of ".. Relog.SubLower .." to ".. Relog.SubLower+Relog.SubWidth)
			Relog:CancelScheduledEvent("DetermineSubSecond")
		end
	end
	
	Relog.SubLastTime=UpperTime
	Relog.SubLastTime2=CurTime
end

function Relog:GetSubsecond()
	local T=GetTime()
	T=T-Relog.SubLower+Relog.SubWidth/2
	T=T-math.floor(T)
	return T
end

function Relog:GetTime()
	return time()+Relog:GetSubsecond()
end



function Relog:OnInitialize()
	Relog.SubLastTime=GetTime()
	Relog.SubLastTime2=time()

	Relog:ScheduleRepeatingEvent("DetermineSubSecond",Relog.DetermineSubsecond,0)
end

function Relog:OnEnable(first)
	Relog.Parse.SetupParser()
end