-- buff = { "victim", "skill", "amountRank" },
-- cast = { "source", "skill", "victim", "isBegin", "isPerform" },
-- create = { "source", "item" },
-- death = { "victim", "source", "skill", "isItem" },
-- debuff = { "victim", "skill", "amountRank" },
-- dispel = { "victim", "skill", "source", "sourceSkill", "isFailed" },
-- drain = { "source", "victim", "skill", "amount", "attribute" },
-- durability = { "source", "skill", "victim", "item" }, -- is not item then isAllItems = true
-- enchant = { "source", "victim", "skill", "item" },
-- environment = { "victim", "amount", "damageType" },
-- experience = { "amount", "source", "bonusAmount", "bonusType", "penaltyAmount", "penaltyType", "amountRaidPenalty", "amountGroupBonus", "victim" },
-- extraattack = { "victim", "skill", "amount" },
-- fade = { "victim", "skill" },
-- fail = { "source", "skill", "reason" },
-- feedpet = { "victim", "item" },
-- gain = { "source", "victim", "skill", "amount", "attribute" },
-- heal = { "source", "victim", "skill", "amount", "isCrit", "isDOT" },
-- hit = { "source", "victim", "skill", "amount", "element", "isCrit", "isDOT", "isSplit" },
-- honor = { "amount", "source", "sourceRank" }, -- if amount == false then isDishonor = true.
-- interrupt = { "source", "victim", "skill" },
-- leech = { "source", "victim", "skill", "amount", "attribute", "sourceGained", "amountGained", "attributeGained" },
-- miss = { "source", "victim", "skill", "missType" },
-- reputation = { "faction", "amount", "rank", "isNegative" },


local Parse={}
Relog.Parse=Parse

function Parse.Aura(info)
	if info.isBuff then
		Parse.AddLog("Buff", nil, nil, info.recipientName, info.recipientID, info.abilityName, nil, info.applications)
	else
		Parse.AddLog("Debuff", nil, nil, info.recipientName, info.recipientID, info.abilityName, nil, info.applications)
	end
end

function Parse.Cast(info)
	Parse.AddLog("Cast", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, nil, info.isBegin, info.isPerform)
end

function Parse.Create(info)
	if info.isCreated then
		Parse.AddLogItem(info.sourceName, info.sourceID, "Create", info.amount, info.itemLink, info.itemName, info.itemRarity, info.itemString)
	else
		Parse.AddLogItem(info.sourceName, info.sourceID, "Loot", info.amount, info.itemLink, info.itemName, info.itemRarity, info.itemString)
	end
end

function Parse.Damage(info)
	local Result="Hit"

	if info.isCrit then
		Result="Crit"
	elseif info.isDoT then
		Result="Tick"
	elseif info.isGlancing then
		Result="Glancing"
	elseif info.isCrushing then
		Result="Crushing"
	elseif info.isSplit then
		Result="Split"	
	ends

	Parse.AddDamageLog(info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, Result, info.Amount, info.absorbAmount, info.blockAmount, info.resistAmount, info.vulnerableAmount)
end


function Parse.SetupParser()
	Relog:RegisterParserEvent({eventType = "Aura"}, Parse.Aura)
	Relog:RegisterParserEvent({eventType = "Cast"}, Parse.Cast)
	Relog:RegisterParserEvent({eventType = "Create"}, Parse.Create)
	Relog:RegisterParserEvent({eventType = "Damage"}, Parse.Damage)
end


--Still need to 
function Parse.AddLog(Type, Source, SourceUnit, Victim, VictimUnit, Ability, Result, Amount, Amount2)
	local num=Relog.db.char.NextLog
	local log=Relog.db.char.Log

	log.Time=Relog:GetTime()
	log.Type[num]=Type
	log.Source[num]=Source
	log.Victim[num]=Victim
	log.Ability[num]=Ability
	log.Result[num]=Result
	log.Amount[num]=Amount
	log.Amount2[num]=Amount2


	log.bonusAmount[num]=bonusAmount
	log.bonusType[num]=bonusType
	log.penaltyAmount[num]=penaltyAmount
	log.penaltyType[num]=penaltyType
	log.amountRaidPenalty[num]=amountRaidPenalty
	log.amountGroupBonus[num]=amountGroupBonus

	Relog.db.char.LastLog=num
	Relog.db.char.NextLog=num+1
end

function Parse.AddDamageLog(Source, SourceUnit, Victim, VictimUnit, Ability, Result, Amount, absorbAmount, blockAmount, resistAmount, vulnerableAmount)
	local num=Relog.db.char.NextLog
	local log=Relog.db.char.Log

	log.Time=Relog:GetTime()
	log.Type[num]="Damage"
	log.Source[num]=Source
	log.Victim[num]=Victim
	log.Ability[num]=Ability
	log.Result[num]=Result

	log.Amount[num]=Amount
	log.absorbAmount[num]=absorbAmount
	log.blockAmount[num]=blockAmount
	log.resistAmount[num]=resistAmount
	log.vulnerableAmount[num]=vulnerableAmount

	Relog.db.char.LastLog=num
	Relog.db.char.NextLog=num+1
end

function Parse.AddLogItem(Source, SourceUnit, Result, Amount, itemLink, itemName, itemRarity, itemString)
	local num=Relog.db.char.NextLog
	local log=Relog.db.char.Log

	log.Time=Relog:GetTime()
	log.Type[num]="Item"
	log.Source[num]=Source
	log.Victim[num]=Victim	
	log.Result[num]=Result
	log.Amount[num]=Amount

	log.itemLink[num]=itemLink
	log.itemName[num]=itemName
	log.itemRarity[num]=itemRarity
	log.itemString[num]=itemString

	Relog.db.char.LastLog=num
	Relog.db.char.NextLog=num+1
end

function Parse.AddLogExperience(Type, Source, SourceUnit, Victim, VictimUnit, Ability, Result, Amount,
		--Items just for Experience which requires several extra
		bonusAmount, bonusType, penaltyAmount, penaltyType, amountRaidPenalty, amountGroupBonus)
	local num=Relog.db.char.NextLog
	local log=Relog.db.char.Log

	log.Time=Relog:GetTime()
	log.Type[num]=Type
	log.Source[num]=Source
	log.Victim[num]=Victim
	log.Ability[num]=Ability
	log.Result[num]=Result
	log.Amount[num]=Amount

	log.bonusAmount[num]=bonusAmount
	log.bonusType[num]=bonusType
	log.penaltyAmount[num]=penaltyAmount
	log.penaltyType[num]=penaltyType
	log.amountRaidPenalty[num]=amountRaidPenalty
	log.amountGroupBonus[num]=amountGroupBonus

	Relog.db.char.LastLog=num
	Relog.db.char.NextLog=num+1
end